/*
    FLUIdS - local search system
    Copyright (C) 1998, 2000  VVK (valera@sbnet.ru), CNII Center, Moscow

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "zdefs.h"
#include "_pstring.h" /* <string.h> */

#include "cfg.h"
#include "error.h"

#if defined( RUSSIAN_SUPPORT ) && defined( RUSSIAN_RELEASE ) &&\
    defined( UKRAINIAN_SUPPORT ) && defined( UKRAINIAN_INTERFACE )
ZDEF(const char * const) fluErrorUkrainianFormats[] =
{
  /* errNoError                      */ "",
  /* errProgParams                   */ "",
  /* errDifferentCharset             */ "  ᭮ 䠩 \"%.1000s\"    ஡  .",
  /* errIndexFileFormat              */ "୨ ଠ ᭮ 䠩 \"%.1000s\".",
  /* errIndexFileOpen                */ "  ᭮ 䠩 \"%.1000s\": %.100s",
  /* errIndexFileSeek                */ " ⠭   ᭮ 䠩 \"%.1000s\": %.100s",
  /* errIndexFileTell                */ " 室 祭   ᭮ 䠩 \"%.1000s\": %.100s",
  /* errIndexFileVersion             */ " ᭮ 䠩  ⨬ \"%.1000s\".",
  /* errIndexFileSize                */ " ᭮ 䠩 \"%.1000s\"    祭,    .",
  /* errIndexFileId                  */ " \"%.1000s\"   ଠ ᭮ 䠩 FLUIdS.",
  /* errIndexChecksum                */ "ୠ ஫쭠 㬠 ᭮ 䠩 \"%.1000s\".",
  /* errIndexFileCount               */ "᫮ ᮢ 㬥  ᭮ 䠩 \"%.1000s\" ॢ ᨬ쭮 ⨬.",
  /* errIndexFileOffsetsCount        */ "᫮ 䠩   ᭮ 䠩 \"%.1000s\"    ᫮ ᮢ 䠩,    .",
  /* errIndexFileStructuresCount     */ "᫮ 䠩 ୨   ᭮ 䠩 \"%.1000s\"    ᫮ ᮢ 䠩,    .",
  /* errIndexFileOffsets             */ " 祭 䠩   ᭮ 䠩 \"%.1000s\".",
  /* errIndexWordTrackSize           */ " ४   ᭮ 䠩 \"%.1000s\"    ஧஬,    .",
  /* errIndexWordTrackOffsets        */ " 祭   ४  ᭮ 䠩 \"%.1000s\".",
#ifdef CHECK
  /* errIndexOffsets                 */ " 祭    ᭮ 䠩 \"%.1000s\".",
#endif
  /* errIndexFileRead                */ " ⠭ ᭮ 䠩 \"%.1000s\": %.100s",
#ifdef CHECK
  /* errIndexFileReadInfo            */ "Cann't read the info of index file \"%.1000s\": %.100s",
  /* errIndexFileReadStopWords       */ "Cann't read the stop words of index file \"%.1000s\": %.100s",
  /* errIndexFileReadValidWords      */ "Cann't read the short words of index file \"%.1000s\": %.100s",
  /* errIndexFileReadFileInfo        */ "Cann't read the file info of index file \"%.1000s\": %.100s",
#endif
  /* errIndexFileWrite               */ "   ᭨ 䠩 \"%.1000s\": %.100s",
#ifdef CHECK
  /* errIndexFileWriteHeader         */ "Cann't write the header of index file \"%.1000s\": %.100s",
  /* errIndexFileWriteInfo           */ "Cann't write the info of index file \"%.1000s\": %.100s",
  /* errIndexFileWriteStopWords      */ "Cann't write the stop words of index file \"%.1000s\": %.100s",
  /* errIndexFileWriteValidWords     */ "Cann't write the valid words of index file \"%.1000s\": %.100s",
  /* errIndexFileWriteFileOffsets    */ "Cann't write the file offsets of the index file \"%.1000s\": %.100s",
  /* errIndexFileWriteFileStructures */ "Cann't write the file structures of the index file \"%.1000s\": %.100s",
  /* errIndexFileWriteFileInfo       */ "Cann't write the index file info of \"%.1000s\": %.100s",
#endif
  /* errIndexFileOverlappingNames    */ "   ᭨ 䠩,  .",
  /* errInvalidFilenoValue           */ "୥ 祭   䠩 (%u)   맮 \"%.100s\".",
  /* errNoSuchDocument               */ " ⠪ 㬥 \"%.1000s\"  ᭮ 䠩 \"%.1000s\"",
  /* errNoQuery                      */ "⨩ 冷 . -᪠,  .",
  /* errQuote                        */ " ,  뢠 ࠧ \"",
  /* errBlankQuotedString            */ " 箢 ᫮ । \"\"",
  /* errClosingParanthis             */ " ᪮,  뢠 ')'",
  /* errNoReasonableQuery            */ " 箢 ᫮     ⨭ ",
  /* errStopWord                     */ "箢 ᫮ '%.100s'  ⮢,   쮬  ஢",
  /* errShortWord                    */ " ⪥ 箢 ᫮ '%.100s'",
  /* errLongWord                     */ "  箢 ᫮ '%.100s'",
  /* errBeginChar                    */ "箢 ᫮   稭  ᨬ '%c' [%.100s]",
  /* errEndChar                      */ "箢 ᫮   㢠 ᨬ '%c' [%.100s]",
  /*                                 */ NULL
};
#endif
