/*
    FLUIdS - local search system
    Copyright (C) 1998, 2000  VVK (valera@sbnet.ru), CNII Center, Moscow

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "zdefs.h"
#include "zchars.h"

#include "defs.h"
#include "searcher.h"
#include "structur.h"

_st_t getAreaValue( const char *string )
{
  _st_t structure = 0;

  for( ; *string != '\0'; string++)
    switch( toLower( *string ) )
    {
      case AREA_CHAR_KEYWORD:
        zSetFlags( structure, FS_AREA_KEYWORD);
        break;
      case AREA_CHAR_CONTENT:
        zSetFlags( structure, FS_AREA_CONTENT);
        break;
      case AREA_CHAR_TITLE:
        zSetFlags( structure, FS_AREA_TITLE);
        break;
      case AREA_CHAR_FILENAME:
        zSetFlags( structure, FS_AREA_FILENAME);
        break;
    }

  return structure;
}
