/*
    FLUIdS - local search system
    Copyright (C) 1998, 2000  VVK (valera@sbnet.ru), CNII Center, Moscow

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "zdefs.h"
#include "_pstring.h" /* <string.h> */
#include <stdlib.h>

#include "zcontext.h"
#include "zchars.h"

#include "cfg.h"
#include "values.h"

void setVerboseValue( struct zcontext_t *cnt, const char *string)
{
  if( string == NULL )
    cnt->verboseLevel = DEFAULT_VERBOSE_LEVEL;
  else
  {
    if( isDigit( *string ) )
      cnt->verboseLevel = (int) strtol( string, NULL, 10);
    else
      cnt->verboseLevel = 3;

    if( cnt->verboseLevel > 3 )
      cnt->verboseLevel = 3;
    else if( cnt->verboseLevel < 0 )
      cnt->verboseLevel = 0;
  }
}
