/*
    LIBZ
    Copyright (C) 1998, 2000  VVK (valera@sbnet.ru), CNII Center, Moscow

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "zdefs.h"
#include "_pstring.h" /* <string.h> */

#include "zerror.h"

#if defined( RUSSIAN_SUPPORT )
ZDEF(const char * const) zErrorRussianFormats[zecLastError+1] =
{
  /* zecNone                    */ "",
  /* zecInetArea                */ "",
  /* zecInternalError           */ "७ 訡: 䠩 \"%.1000s\", ப %d",
  /* zecExternalError           */ " 訡: %.100s: %.1000s",
  /* zecInvalidValue            */ "୮ 祭 㬥()  맮 㭪樨 %.100s()",
  /* zecValueRange              */ "",
  /* zecSameValue               */ "",
  /* zecNotInited               */ "",
  /* zecNotSupported            */ "",
  /* zecNoMemory                */ " ᢮ ⨢  (%.100s)",
  /* zecSystemTime              */ "訡 祭 ⥬ ६",
  /* zecTimeValue               */ "",
  /* zecTimeString              */ "",
  /* zecUnknownCharset          */ "⭠ ஢ '%.100s'",
  /* zecBufferLimit             */ "",
  /* zecInvalidStringFormat     */ "",
  /* zecDataError               */ "",
  /* zecProcCreate              */ "訡 ᮧ  ",
  /* zecTempFileName            */ "訡 樨  ६ 䠩",
  /* zecZeroLengthFile          */ " \"%.1000s\" - 㫥 ",
  /* zecUnexpectedFileEnd       */ "  䠩 \"%.1000s\"",
  /* zecFileFormat              */ " ଠ 䠩 \"%.1000s\"",
  /* zecFileId                  */ "",
  /* zecFileSize                */ " 䠩 \"%.1000s\" , 祬  㪠  ",
  /* zecFileLength              */ " 䠩 \"%.1000s\" , 祬 ࠧ ",
  /* zecFileOpen                */ "訡  䠩 \"%.1000s\": %.100s",
  /* zecFileTell                */ "訡 । 祭 㪠⥫  䠩 \"%.1000s\": %.100s",
  /* zecFileSeek                */ "訡 ⠭ 㪠⥫  䠩 \"%.1000s\": %.100s",
  /* zecFileStat                */ "訡 祭 ਡ⮢ 䠩 \"%.1000s\": %.100s",
  /* zecFileLock                */ "訡 ஢ 䠩 \"%.1000s\": %.100s",
  /* zecFileRead                */ "訡 ⥭ 䠩 \"%.1000s\": %.100s",
  /* zecFileWrite               */ "訡   䠩 \"%.1000s\": %.100s",
  /* zecFileRename              */ "訡 २ 䠩  \"%.1000s\"  \"%.1000s\": %.100s",
  /* zecFileAccess              */ " \"%.1000s\":  ⢥",
  /* zecFileExist               */ " \"%.1000s\" 㦥 ",
  /* zecFileMmap                */ "訡 ᮧ 樨 䠩 \"%.1000s\": %.100s",
  /* zecFileDup                 */ "訡 㯫஢ ਯ 䠩 \"%.1000s\": %.100s",
  /* zecTempFileFormat          */ " ଠ ६ 䠩",
  /* zecTempFileOpen            */ "訡  ६ 䠩: %.100s",
  /* zecTempFileTell            */ "訡 । 祭 㪠⥫  ६ 䠩: %.100s",
  /* zecTempFileSeek            */ "訡 ⠭ 㪠⥫  ६ 䠩: %.100s",
  /* zecTempFileStat            */ "訡 祭 ਡ⮢ ६ 䠩: %.100s",
  /* zecTempFileRead            */ "訡 ⥭ ६ 䠩: %.100s",
  /* zecTempFileWrite           */ "訡   ६ 䠩: %.100s",
  /* zecTempFileRename          */ "訡 २ ६ 䠩  \"%.1000s\": %.100s",
  /* zecTempDirNotExist         */ "  ४ਨ  ६ 䠩 \"%.1000s\"",
  /* zecTempDirRights           */ " ࠢ   ४  ६ 䠩 \"%.1000s\"",
  /* zecTempDirIsntDir          */ "祭 \"%.1000s\",   ⢥ ४ਨ  ६ 䠩,   ४ਥ",
  /* zerPipeCreate              */ "訡 ᮧ ணࠬ : %.100s",
  /* zecDirCreate               */ "訡 ᮧ ४ਨ \"%.1000s\": %.100s",
  /* zecDirOpen                 */ "訡  ४ਨ \"%.1000s\": %.100s",
  /* zecNotDirectory            */ "  \"%.1000s\" (   楫)   ४ਥ",
  /* zecNotRegularFile          */ " \"%.1000s\"   ॣ",
  /* zecInvalidPattern          */ " 訡 蠡 '%.1000s'",
  /* zecConfFileOpen            */ "訡  䨣樮 䠩 \"%.1000s\" : %.100s",
  /* zecConfInvalidStringFormat */ " ଠ ப ( %d)  䨣樮 䠩 \"%.1000s\"",
  /* zecConfUnknownSection      */ " ࠧ   '%.100s'  䨣樮 䠩 \"%.1000s\"",
  /* zecConfUnknownKeyword      */ "⭠ ४⨢ '%.100s'  ப  %d 䨣樮 䠩 \"%.1000s\"",
  /* zecConfInvalidValue        */ " ୮ 祭  ࠬ '%.100s'  䨣樮 䠩 \"%.1000s\", ப %d",
  /* zecNeedRecursive           */ "  蠡 '%.1000s' 室 ४",
  /* zecLastError               */ NULL
};
#endif
