/*
    LIBZ
    Copyright (C) 1998, 2000  VVK (valera@sbnet.ru), CNII Center, Moscow

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "zdefs.h"
#include "_pstring.h" /* <string.h> */

#include "zerror.h"

#if defined( RUSSIAN_SUPPORT ) && defined( UKRAINIAN_SUPPORT )
ZDEF(const char * const) zErrorUkrainianFormats[zecLastError+1] =
{
  /* zecNone                    */ "",
  /* zecInetArea                */ "",
  /* zecInternalError           */ "Internal error: file \"%.1000s\", line %d",
  /* zecExternalError           */ "External error: %.100s: %.1000s",
  /* zecInvalidValue            */ "Invalid argument(s) in function %.100s()",
  /* zecValueRange              */ "",
  /* zecSameValue               */ "",
  /* zecNotInited               */ "",
  /* zecNotSupported            */ "",
  /* zecNoMemory                */ " 쭮 ⨢ ' (%.100s)",
  /* zecSystemTime              */ " ਬ ⥬ ",
  /* zecTimeValue               */ "",
  /* zecTimeString              */ "",
  /* zecUnknownCharset          */ "   '%.100s'",
  /* zecBufferLimit             */ "",
  /* zecInvalidStringFormat     */ "",
  /* zecDataError               */ "",
  /* zecProcCreate              */ " ⢮७  ",
  /* zecTempFileName            */ "   ⨬ᮢ 䠩",
  /* zecZeroLengthFile          */ " \"%.1000s\" - 쮢 ",
  /* zecUnexpectedFileEnd       */ "㢠  䠩 \"%.1000s\"",
  /* zecFileFormat              */ "Invalid format of the file \"%.1000s\"",
  /* zecFileId                  */ "",
  /* zecFileSize                */ "The length of the file \"%.1000s\" is less than it stated in the header",
  /* zecFileLength              */ "The length of the file \"%.1000s\" is less than the header size",
  /* zecFileOpen                */ "  䠩 \"%.1000s\": %.100s",
  /* zecFileTell                */ " 室 祭   䠩 \"%.1000s\": %.100s",
  /* zecFileSeek                */ " ⠭   䠩 \"%.1000s\": %.100s",
  /* zecFileStat                */ " ਬ ਡ 䠩 \"%.1000s\": %.100s",
  /* zecFileLock                */ "Cann't lock the file \"%.1000s\": %.100s",
  /* zecFileRead                */ " ⠭ 䠩 \"%.1000s\" : %.100s",
  /* zecFileWrite               */ "   䠩 \"%.1000s\": %.100s",
  /* zecFileRename              */ " 㢠 䠩  \"%.1000s\"  \"%.1000s\": %.100s",
  /* zecFileAccess              */ " \"%.1000s\":   ",
  /* zecFileExist               */ " \"%.1000s\"  ",
  /* zecFileMmap                */ " ⢮७ ஥ 䠩 \"%.1000s\": %.100s",
  /* zecFileDup                 */ " 㯫㢠 ਯ 䠩 \"%.1000s\": %.100s",
  /* zecTempFileFormat          */ "Invalid format of the temporary file",
  /* zecTempFileOpen            */ "  ⨬ᮢ 䠩: %.100s",
  /* zecTempFileTell            */ " 室 祭   ⨬ᮢ 䠩: %.100s",
  /* zecTempFileSeek            */ " ⠭   ⨬ᮢ 䠩: %.100s",
  /* zecTempFileStat            */ " ਬ ਡ ⨬ᮢ 䠩: %.100s",
  /* zecTempFileRead            */ " ⠭ ⨬ᮢ 䠩: %.100s",
  /* zecTempFileWrite           */ "   ⨬ᮢ 䠩: %.100s",
  /* zecTempFileRename          */ " 㢠 ⨬ᮢ 䠩  \"%.1000s\": %.100s",
  /* zecTempDirNotExist         */ " ४  ⨬ᮢ 䠩,    \"%.1000s\"",
  /* zecTempDirRights           */ " ࠢ    ४  ⨬ᮢ 䠩 \"%.1000s\"",
  /* zecTempDirIsntDir          */ "祭 \"%.1000s\",    ४  ⨬ᮢ 䠩,   ४",
  /* zerPipeCreate              */ " ⢮७ ணࠬ : %.100s",
  /* zecDirCreate               */ " ⢮७ ४ \"%.1000s\": %.100s",
  /* zecDirOpen                 */ "  ४ \"%.1000s\": %.100s",
  /* zecNotDirectory            */ "⨭  \"%.1000s\" (   )   ४",
  /* zecNotRegularFile          */ " \"%.1000s\"   ॣ୨",
  /* zecInvalidPattern          */ "  蠡 '%.1000s'",
  /* zecConfFileOpen            */ "  䠩  \"%.1000s\" : %.100s",
  /* zecInvalidConfStringFormat */ "୨ ଠ 浪 ( %d)  䨣 䠩 \"%.1000s\"",
  /* zecUnknownConfBlock        */ " ஧   '%.100s'  䠩  \"%.1000s\"",
  /* zecUnknownConfKeyword      */ " ४⨢ '%.100s'  浪  %d 䠩  \"%.1000s\"",
  /* zecInvalidConfValue        */ " ୥ 祭  ࠬ '%.100s'  䠩  \"%.1000s\", 冷 %d",
  /* zecNeedRecursive           */ " 蠡,  , '%.1000s'  ४",
  /* zecLastError               */ NULL
};
#endif
