/*
    LIBZ
    Copyright (C) 1998, 2000  VVK (valera@sbnet.ru), CNII Center, Moscow

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "zdefs.h"
#include "ztime.h"

zint_t zGetTimeNumber( zint_t maxNumber )
{
  struct ztimeval_t tv;
  zint_t number;

  if( !zInitTimeValue( &tv ) )
    number = 1;
  else
  {
#if defined( HAVE_GETTIMEOFDAY )
    number = (zint_t) (tv.tv.tv_usec % maxNumber);
#elif defined( HAVE_FTIME )
    number = (zint_t) (tv.tv.millitm % maxNumber);
#else
    number = (zint_t) (tv.tv % maxNumber);
#endif
  }

  return number;
}
